--SEE README

local state
local states = {}

local function newState(name)
	states[name] = require(name); states[name].load()
end

local function setState(name, data)
	if states[state] and states[state].exit then states[state].exit() end
	state = name
	if states[state].enter then states[state].enter(data) end
end

function love.load()
	newState("logo")
	newState("menu")
	newState("play")
	newState("error")

	setState("logo")
end

function love.errhand(msg)	--the way I'm doing this doesn't work
	setState("error", {msg})
end

function love.update(dt)
	if states[state].update then
		local nextState, data = states[state].update(dt)
		if nextState then
			setState(nextState, data)
		end
	end
end

function love.draw()
	if states[state].draw then states[state].draw() end
end

function love.keypressed(k, r) if states[state].keypressed then states[state].keypressed(k, r) end end
function love.keyreleased(k) if states[state].keyreleased then states[state].keyreleased(k) end end

function love.textinput(text) if states[state].textinput then states[state].textinput(text) end end

function love.mousemoved(x, y, dx, dy) if states[state].mousemoved then states[state].mousemoved(x, y, dx, dy) end end
function love.mousepressed(x, y, b) if states[state].mousepressed then states[state].mousepressed(x, y, b) end end
function love.mousereleased(x, y, b) if states[state].mousereleased then states[state].mousereleased(x, y, b) end end
