local utf8 = require "utf8"

local menu = {}

function menu.load()
	menu.font = love.graphics.newFont(30)
end

function menu.enter()
	menu.address = "Press enter for error (intended)"
	love.keyboard.setTextInput(true)
    love.keyboard.setKeyRepeat(true)
end

function menu.update(dt)
	if love.keyboard.isDown("return") then
		mat.sin(3)	--here's the error
		return "play", {menu.address}
	end
end

function menu.draw()
	love.graphics.setFont(menu.font)
	love.graphics.print("Enter server address:", 10, 10)
	love.graphics.print(menu.address..(love.timer.getTime()*2%2<1 and "|" or ""), 10, 40)
end

function menu.textinput(t)
	t = t or ""
    menu.address = menu.address .. t
end

function menu.keypressed(key)
    if key == "backspace" then
        local byteoffset = utf8.offset(menu.address, -1)

        if byteoffset then
            menu.address = string.sub(menu.address, 1, byteoffset - 1)
        end
    end
end

return menu
